; PIANO.ASM (c) Fock Ping Olivier  (27/05/97)
; =========
; Vous pouvez me contacter  fockpingolive@geocities.com
; ou visiter mon site  http://www.geocities.com/SiliconValley/Vista/3244/
;
; Merci :
; - Markus Klisics (l'inventeur du son sur TI-92)
; - Tim Gerla (pour sa routine simplifie)
; - Rolf ALber (pour RECLIB)

WriteStr	MACRO
	move.w	\3,-(a7)
	pea	\4(PC)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	romlib[puttext]
	lea	10(a7),a7
		ENDM

SetFont 	 MACRO
	move.w	\1,-(a7)
	jsr	romlib[set_font]
	lea	2(a7),a7
		ENDM

	@program	prog_code,prog_name
prog_code:
	jsr		reclib[init]

        lea             LCD_MEM,a0      ; efface l'cran
        move.w          #959,d0
\loop1
        clr.l           (a0)+
        dbf.s           d0,\loop1

	SetFont		#2
	WriteStr	#70,#10,#4,Text1
	WriteStr	#60,#70,#4,Text7
	WriteStr	#60,#80,#4,Text8
	SetFont		#0
	WriteStr	#60,#23,#4,Text2
	WriteStr	#20,#105,#4,Text3
	WriteStr	#20,#112,#4,Text4
	SetFont		#1
	WriteStr	#35,#40,#4,Text5
	WriteStr	#35,#50,#4,Text6

	move.w		#54,a2		; octave 4 par dfaut

        lea             tones(PC),a0	; adresse de la table des frquences
	lea             duration(PC),a1	; adresse de la table des dures

loop:
	cmp.w		#264,d0		; Echap ?
	beq		end
	cmp.w		#267,d0		; F1...F4 ?
	bgt		Touches_Fonction
idle_loop:
	stop		#$2000
	tst.w		($75B0)		; Une touche a t enfonce ?
	beq		idle_loop
	move.w		($75B2),d0
	clr.w		($75B0)

	cmp.w		#136,d0		; Touche teta ?
	bne		No_teta
	move.w		#26,d0
	bra		Suite1		; non
Touches_Fonction:
	cmp.w		#271,d0		; > F4 ?
	bgt		idle_loop
	sub.w		#268,d0		; F1 -> octave 2
	mulu.w		#27,d0		; F2 -> octave 3
	move.w		d0,a2		; F3 -> octave 4
	bra		idle_loop	; F4 -> octave 5
No_teta:
	cmp.w		#122,d0		; a..z ?
	bgt		loop
	cmp.w		#97,d0
	blt		idle_loop
	sub.w		#97,d0
Suite1:
        add.w           a2,d0           ; Ajuste l'octave
        lsl.w           #1,d0           ; d0*2, parce que les frquences dans le
                                        ; tableau sont de type WORD (2*BYTE)
        move.w          0(a0,d0),d6     ; d6 contient la bonne frquence
        cmp.w           #0,d6           ; si frquence=0, on ne joue pas
        beq             loop
        move.w          0(a1,d0),d7     ; d7 contient la dure

;****************************************************************************
; Routine de Tim Gerla
;****************************************************************************
sound:
        move.w          #$2700,sr               ;disable interrupts for
                                                ;smoother sound
        move.b          #00,($60000e)           ;turn off red & white wires
        or.w            #$0c00,($60000e)        ;turn them on
        move.l          d6,-(a7)                ;save freq
soundloop:
        dbf.w           d6,soundloop            ;wait
        move.l          (a7)+,d6                ;restore freq
        dbf.w           d7,sound                ;branch back
        move.w          #$2000,sr               ;enable interrupts

;****************************************************************************
; Fin de la routine
;****************************************************************************

	bra		idle_loop
end:
        rts					; Fin du programme

Text1		dc.b	"Piano ver 1.0",0
Text2		dc.b	" 1997 FOCK PING Olivier  (28/05/97)",0
Text3		dc.b	"http://www.geocities.com/SiliconValley/Vista/3244/",0
Text4		dc.b	"fockpingolive@geocities.com",0
Text5		dc.b	"F1..F2 : Changer d'octave",0
Text6		dc.b	"ESC    : Quitter",0
Text7		dc.b    " |S|D| |G|H|J|",0
Text8		dc.b	"|Z|X|C|V|B|N|M|",136,"|",0

prog_name       dc.b    "Piano 1.0 - FOCK PING Olivier",0

tones:
;do#2-do#3
    dc.w  0,3429,4131,4353,0,0,3635,3245,0,2895,0,0,2730,3079,0,0,0,0,4876,0,0,3867,0,4600,0,5188,2556
;do#3-do#4
    dc.w  0,1690,2035,2145,0,0,1791,1599,0,1426,0,0,1345,1517,0,0,0,0,2403,0,0,1906,0,2267,0,2556,1260
;do#4-do#5
    dc.w  0,833,1003,1057,0,0,883,788,0,703,0,0,663,748,0,0,0,0,1184,0,0,939,0,1117,0,1260,621
;do#5-do#6
    dc.w  0,410,494,521,0,0,435,388,0,346,0,0,327,368,0,0,0,0,583,0,0,463,0,550,0,621,306

duration:
;do#2-do#3
    dc.w  0,11,9,9,0,0,10,11,0,13,0,0,14,12,0,0,0,0,8,0,0,9,0,8,0,8,15
;do#3-do#4
    dc.w  0,22,19,17,0,0,21,23,0,26,0,0,28,25,0,0,0,0,16,0,0,20,0,17,0,15,29
;do#4-do#5
    dc.w  0,45,38,35,0,0,42,47,0,53,0,0,56,50,0,0,0,0,32,0,0,40,0,34,0,29,60
;do#5-do#6
    dc.w  0,91,75,71,0,0,86,95,0,107,0,0,113,101,0,0,0,0,64,0,0,80,0,68,0,60,121


 reloc_open
 add_library    romlib
 add_library	reclib
 reloc_close
 end
